# CTRL hookup guides

Welcome to our collection of hookup guides! Building circuits can be 
both exciting and challenging, but with these step-by-step instructions, 
you'll be connecting components like a pro in no time.

Whether you're just starting out or looking to expand your skills, our 
guides cover everything from basic button connections to more advanced 
multiplexer setups. Each guide is designed to be clear, concise, and 
easy to follow.

- [Button hookup guide](buttons.md): Learn how to incorporate buttons into your circuits and add interactive functionality.
- [Potentiometer hookup guide](potentiometers.md): Explore the versatility of potentiometers and their applications in analog circuits.
- [Rotary encoder hookup guide](rotary_encoders.md): Discover how rotary encoders can be used for precise control and navigation in your projects.
- [Multiplexer hookup guide](multiplexers.md): Master the use of multiplexers to expand your input/output capabilities and streamline your circuit designs.
